Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_reader.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_reader.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_reader.f90	(revision 2528)
@@ -0,0 +1,298 @@
+module m_reader
+
+use m_io
+
+private
+
+integer, parameter, public              :: BUFFER_NOT_CONNECTED = -2048
+integer, private, parameter             :: MAXLENGTH = 1024
+
+type, public :: file_buffer_t
+private
+      logical                           :: connected
+      logical                           :: eof
+      integer                           :: lun
+      character(len=50)                 :: filename
+      integer                           :: counter
+      character(len=MAXLENGTH)          :: buffer
+      integer                           :: line
+      integer                           :: col
+      integer                           :: pos 
+      integer                           :: nchars
+      logical                           :: debug
+end type file_buffer_t
+
+public  :: get_character, sync_file
+public  :: line, column, nchars_processed
+public  :: open_file, close_file_buffer, rewind_file, mark_eof_file
+public  :: eof_file
+
+private :: fill_buffer
+
+CONTAINS
+
+!-----------------------------------------
+!
+subroutine open_file(fname,fb,iostat,record_size,verbose)
+character(len=*), intent(in)      :: fname
+type(file_buffer_t), intent(out)  :: fb
+integer, intent(out)              :: iostat
+integer, intent(in), optional     :: record_size
+logical, intent(in), optional     :: verbose
+
+iostat = 0
+
+call setup_io()
+
+fb%connected = .false.
+
+call get_unit(fb%lun,iostat)
+if (iostat /= 0) then
+   if (fb%debug) print *, "Cannot get unit"
+   return
+endif
+
+if (present(verbose)) then
+   fb%debug = verbose
+else
+   fb%debug = .false.
+endif
+
+if (present(record_size)) then
+   open(unit=fb%lun,file=fname,form="formatted",status="old", &
+        action="read",position="rewind",recl=record_size,iostat=iostat)
+else
+   open(unit=fb%lun,file=fname,form="formatted",status="old", &
+        action="read",position="rewind",recl=65536,iostat=iostat)
+endif
+if (iostat /= 0) then
+   if (fb%debug) print *, "Cannot open file ", trim(fname), " iostat: ", iostat
+   return
+endif
+
+fb%connected = .true.
+fb%counter = 0
+fb%eof = .false.
+fb%line = 1
+fb%col = 0
+fb%filename = fname
+fb%pos = 0
+fb%nchars = 0
+fb%buffer = ""
+
+end subroutine open_file
+
+!-------------------------------------------------
+subroutine rewind_file(fb)
+type(file_buffer_t), intent(inout)  :: fb
+
+fb%eof = .false.
+fb%counter = 0
+fb%line = 1
+fb%col = 0
+fb%pos = 0
+fb%nchars = 0
+fb%buffer = ""
+
+rewind(unit=fb%lun)
+
+end subroutine rewind_file
+!-----------------------------------------
+subroutine mark_eof_file(fb)
+type(file_buffer_t), intent(inout)  :: fb
+
+fb%eof = .true.
+
+end subroutine mark_eof_file
+
+!-----------------------------------------
+subroutine close_file_buffer(fb)
+type(file_buffer_t), intent(inout)  :: fb
+
+if (fb%connected) then
+    close(unit=fb%lun)
+    fb%connected = .false.
+endif
+
+end subroutine close_file_buffer
+
+!-------------------------------------------------
+function eof_file(fb) result (res)
+type(file_buffer_t), intent(in)  :: fb
+logical                          :: res
+
+res = fb%eof
+
+end function eof_file
+!-----------------------------------------
+!-----------------------------------------
+! New version, able to cope with arbitrarily long lines 
+! (still need to specify a big enough record_size if necessary)
+!
+subroutine fill_buffer(fb,iostat)
+type(file_buffer_t), intent(inout)  :: fb
+integer, intent(out)  :: iostat
+! 
+!
+character(len=41)  :: str       ! 40 seems like a good compromise?
+                                ! (1 extra for added newline, see below)
+integer            :: len
+!
+read(unit=fb%lun,iostat=iostat,advance="no",size=len,fmt="(a40)") str
+
+if (iostat == io_eof) then
+   
+   ! End of file
+   if (fb%debug) print *, "End of file."
+   return
+
+else if (iostat > 0) then
+
+   ! Hard i/o error
+   if (fb%debug) print *, "Hard i/o error. iostat:", iostat
+   RETURN
+
+else
+!
+ if (fb%debug) then
+   print *, "Buffer: len, iostat", len, iostat
+   print *, trim(str)
+ endif
+
+   fb%pos = 0
+
+   if (iostat == 0) then
+
+      !  Normal read, with more stuff left on the line
+      !
+      fb%buffer = str(1:len) 
+      fb%nchars = len
+
+   else         ! (end of record)
+      !
+      !  End of record. We mark it with an LF, whatever it is the native marker.
+      !
+!!      fb%buffer = str(1:len) // char(10)
+      fb%buffer = str(1:len)             !! Avoid allocation of string
+      len = len + 1                      !! by compiler
+      fb%buffer(len:len) = char(10)   
+      fb%nchars = len
+      iostat = 0
+   endif
+
+endif
+
+end subroutine fill_buffer
+
+!---------------------------------------------------------------
+subroutine get_character(fb,c,iostat)
+character(len=1), intent(out) :: c
+type(file_buffer_t), intent(inout)  :: fb
+integer, intent(out)          :: iostat
+
+character(len=1)   :: c_next
+
+if (.not. fb%connected) then
+      iostat = BUFFER_NOT_CONNECTED
+      return
+endif
+
+if (fb%pos >= fb%nchars) then
+      call fill_buffer(fb,iostat)
+      if (iostat /= 0) return
+endif
+fb%pos = fb%pos + 1
+c = fb%buffer(fb%pos:fb%pos)
+fb%counter = fb%counter + 1              ! Raw counter
+fb%col = fb%col + 1
+!
+! Deal with end-of-line handling on the processor...
+!
+if (c == char(10)) then
+   ! Our own marker for end of line
+   fb%line = fb%line + 1
+   fb%col = 0
+endif
+if (c == char(13)) then
+   c_next = fb%buffer(fb%pos+1:fb%pos+1)
+   if (c_next == char(10)) then
+      !
+      ! Found CRLF. We replace it by LF, as per specs.
+      c = c_next
+      fb%pos = fb%pos + 1
+      if (fb%debug) print *, "-/-> Removed CR before LF in get_character"
+   else
+      ! Replace single CR by LF
+      c = char(10)
+      if (fb%debug) print *, "-/-> Changed CR to LF in get_character -- line++"
+      !
+   endif
+   ! In both cases we increase the line counter and reset the column
+   !
+   fb%line = fb%line + 1
+   fb%col = 0
+endif
+
+iostat = 0
+
+end subroutine get_character
+
+!----------------------------------------------------
+!----------------------------------------------------
+! Error Location functions
+!
+function line(fb) result (ll)
+type(file_buffer_t), intent(in)  :: fb
+integer                          :: ll
+
+ll = fb%line
+end function line
+
+!----------------------------------------------------
+function column(fb) result (col)
+type(file_buffer_t), intent(in)  :: fb
+integer                          :: col
+
+col = fb%col
+end function column
+!----------------------------------------------------
+!----------------------------------------------------
+function nchars_processed(fb) result (nc)
+type(file_buffer_t), intent(in)  :: fb
+integer                          :: nc
+
+nc = fb%counter
+end function nchars_processed
+!----------------------------------------------------
+
+subroutine sync_file(fb,iostat)
+type(file_buffer_t), intent(inout)  :: fb
+integer, intent(out)                :: iostat
+!
+! Repositions the file so that it matches with
+! the stored file_buffer information
+!
+integer          :: target_counter
+character(len=1) :: c
+
+target_counter = fb%counter
+call rewind_file(fb)
+iostat = 0
+do
+   if (fb%counter == target_counter) exit
+   call get_character(fb,c,iostat)
+   if (iostat /= 0) return
+enddo
+
+end subroutine sync_file
+
+end module m_reader
+
+
+
+
+
+
+
+
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_xml_error.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_xml_error.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_xml_error.f90	(revision 2528)
@@ -0,0 +1,84 @@
+module m_xml_error
+!
+! Error handling
+!
+use m_elstack
+private
+
+type, public  :: xml_error_t
+      character(len=100)  :: message
+      integer             :: line
+      integer             :: column
+      type(elstack_t)     :: stack
+      integer             :: severity
+end type xml_error_t
+
+integer, public             ::  xml_stderr = 0    ! Unit for error info
+integer, public, parameter  ::  SEVERE_ERROR_CODE=0, WARNING_CODE=1
+
+public  :: build_error_info, default_error_handler
+public  :: set_xml_stderr
+
+CONTAINS
+
+!-------------------------------------------------------------------------
+subroutine build_error_info(error_info,message,line,column,stack,severity)
+type(xml_error_t), intent(out)        :: error_info
+integer, intent(in)                   :: line, column
+character(len=*), intent(in)          :: message
+type(elstack_t), intent(in)           :: stack
+integer, intent(in)                   :: severity
+
+error_info%message = message
+error_info%line = line
+error_info%column = column
+error_info%stack = stack
+error_info%severity = severity
+
+end subroutine build_error_info
+
+!--------------------------------------------------
+
+subroutine default_error_handler(error_info)
+type(xml_error_t), intent(in)            :: error_info
+!
+! Default error handling
+!
+if (error_info%severity == SEVERE_ERROR_CODE)  then
+   write(unit=xml_stderr,fmt="(a)") "*** XML parsing Error:"
+else if (error_info%severity == WARNING_CODE)  then
+   write(unit=xml_stderr,fmt="(a)") "*** XML parsing Warning:"
+endif
+write(unit=xml_stderr,fmt="(a)") trim(error_info%message)
+write(unit=xml_stderr,fmt="(a,i8,a,i4)") "Line: ", &
+                                         error_info%line, &
+                                         " Column: ", &
+                                         error_info%column
+write(unit=xml_stderr,fmt="(a)") "Element traceback:"
+call print_elstack(error_info%stack,unit=xml_stderr)
+!
+!   If there is a severe error the program should stop...
+!
+if (error_info%severity == SEVERE_ERROR_CODE)  then
+      STOP
+else if (error_info%severity == WARNING_CODE)  then
+   write(unit=xml_stderr,fmt="(a)") "*** Continuing after Warning..."
+endif
+
+end subroutine default_error_handler
+
+!-------------------------------------------------------------------------
+subroutine set_xml_stderr(unit)
+integer, intent(in)  :: unit
+
+xml_stderr  = unit
+
+end subroutine set_xml_stderr
+
+end module m_xml_error
+
+
+
+
+
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_xml_parser.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_xml_parser.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_xml_parser.f90	(revision 2528)
@@ -0,0 +1,506 @@
+module m_xml_parser
+
+!
+! Basic module to parse XML in the SAX spirit.
+!
+
+use m_buffer
+use m_reader
+use m_fsm
+use m_dictionary
+use m_debug
+use m_xml_error
+use m_elstack          ! For element nesting checks
+use m_entities
+!
+private
+
+!
+!  XML file handle
+!
+type, public :: xml_t
+private
+      type(file_buffer_t)  :: fb
+      type(fsm_t)          :: fx
+      character(len=200)   :: path_mark
+end type xml_t
+
+!
+public :: xml_parse
+public :: open_xmlfile, close_xmlfile
+public :: endfile_xmlfile, rewind_xmlfile
+public :: eof_xmlfile, sync_xmlfile
+public :: xml_char_count
+public :: xml_path, xml_mark_path, xml_get_path_mark
+public :: xml_name, xml_attributes
+
+CONTAINS  !=============================================================
+
+subroutine open_xmlfile(fname,fxml,iostat,record_size)
+character(len=*), intent(in)      :: fname
+integer, intent(out)              :: iostat
+type(xml_t), intent(out)          :: fxml
+integer, intent(in), optional     :: record_size
+
+call open_file(fname,fxml%fb,iostat,record_size)
+call init_fsm(fxml%fx)
+fxml%path_mark = ""
+
+end subroutine open_xmlfile
+!-------------------------------------------------------------------------
+
+subroutine rewind_xmlfile(fxml)
+type(xml_t), intent(inout) :: fxml
+
+call rewind_file(fxml%fb)
+call reset_fsm(fxml%fx)
+fxml%path_mark = ""
+
+end subroutine rewind_xmlfile
+
+!-----------------------------------------
+subroutine endfile_xmlfile(fxml)
+type(xml_t), intent(inout) :: fxml
+
+call mark_eof_file(fxml%fb) 
+
+end subroutine endfile_xmlfile
+
+!-----------------------------------------
+subroutine close_xmlfile(fxml)
+type(xml_t), intent(inout) :: fxml
+
+call close_file_buffer(fxml%fb)
+call reset_fsm(fxml%fx)         ! just in case
+fxml%path_mark = ""             ! ""
+
+end subroutine close_xmlfile
+
+!-----------------------------------------
+subroutine sync_xmlfile(fxml,iostat)
+type(xml_t), intent(inout) :: fxml
+integer, intent(out)       :: iostat
+
+call sync_file(fxml%fb,iostat)
+! Do not reset fx: that's the whole point of synching.
+
+end subroutine sync_xmlfile
+
+!----------------------------------------------------
+function eof_xmlfile(fxml) result (res)
+type(xml_t), intent(in)          :: fxml
+logical                          :: res
+
+res = eof_file(fxml%fb)
+
+end function eof_xmlfile
+!
+!----------------------------------------------------
+!----------------------------------------------------
+function xml_char_count(fxml) result (nc)
+type(xml_t), intent(in)          :: fxml
+integer                          :: nc
+
+nc = nchars_processed(fxml%fb)
+
+end function xml_char_count
+!
+!----------------------------------------------------
+!
+
+subroutine xml_parse(fxml, begin_element_handler,    &
+                           end_element_handler,      &
+                           pcdata_chunk_handler,     &
+                           comment_handler,          &
+                           xml_declaration_handler,  &
+                           cdata_section_handler,     &
+                           sgml_declaration_handler, &
+                           error_handler,            &
+                           signal_handler,            &
+                           verbose,                  &
+                           empty_element_handler)
+
+type(xml_t), intent(inout), target  :: fxml
+
+optional                            :: begin_element_handler
+optional                            :: end_element_handler
+optional                            :: pcdata_chunk_handler
+optional                            :: comment_handler
+optional                            :: xml_declaration_handler
+optional                            :: sgml_declaration_handler
+optional                            :: cdata_section_handler
+optional                            :: error_handler
+optional                            :: signal_handler
+logical, intent(in), optional       :: verbose
+optional                            :: empty_element_handler
+
+interface
+   subroutine begin_element_handler(name,attributes)
+   use m_dictionary
+   character(len=*), intent(in)     :: name
+   type(dictionary_t), intent(in)   :: attributes
+   end subroutine begin_element_handler
+
+   subroutine end_element_handler(name)
+   character(len=*), intent(in)     :: name
+   end subroutine end_element_handler
+
+   subroutine pcdata_chunk_handler(chunk)
+   character(len=*), intent(in) :: chunk
+   end subroutine pcdata_chunk_handler
+
+   subroutine comment_handler(comment)
+   character(len=*), intent(in) :: comment
+   end subroutine comment_handler
+
+   subroutine xml_declaration_handler(name,attributes)
+   use m_dictionary
+   character(len=*), intent(in)     :: name
+   type(dictionary_t), intent(in)   :: attributes
+   end subroutine xml_declaration_handler
+
+   subroutine sgml_declaration_handler(sgml_declaration)
+   character(len=*), intent(in) :: sgml_declaration
+   end subroutine sgml_declaration_handler
+
+   subroutine cdata_section_handler(cdata)
+   character(len=*), intent(in) :: cdata
+   end subroutine cdata_section_handler
+
+   subroutine error_handler(error_info)
+   use m_xml_error
+   type(xml_error_t), intent(in)            :: error_info
+   end subroutine error_handler
+
+   subroutine signal_handler(code)
+   logical, intent(out) :: code
+   end subroutine signal_handler
+
+   subroutine empty_element_handler(name,attributes)
+   use m_dictionary
+   character(len=*), intent(in)     :: name
+   type(dictionary_t), intent(in)   :: attributes
+   end subroutine empty_element_handler
+
+end interface
+
+character(len=1)     :: c
+integer              :: iostat, status
+
+character(len=150)   :: message
+integer              :: signal
+
+type(buffer_t)       :: translated_pcdata
+type(buffer_t)       :: name, oldname, dummy
+
+logical              :: have_begin_handler, have_end_handler, &
+                        have_pcdata_handler, have_comment_handler, &
+                        have_xml_declaration_handler, &
+                        have_sgml_declaration_handler, &
+                        have_cdata_section_handler, have_empty_handler, &
+                        have_error_handler, have_signal_handler
+
+logical              :: pause_signal
+
+type(xml_error_t)            :: error_info
+type(file_buffer_t), pointer :: fb
+type(fsm_t), pointer         :: fx
+
+have_begin_handler = present(begin_element_handler)
+have_end_handler = present(end_element_handler)
+have_pcdata_handler = present(pcdata_chunk_handler)
+have_comment_handler = present(comment_handler)
+have_xml_declaration_handler = present(xml_declaration_handler)
+have_sgml_declaration_handler = present(sgml_declaration_handler)
+have_cdata_section_handler = present(cdata_section_handler)
+have_error_handler = present(error_handler)
+have_signal_handler = present(signal_handler)
+have_empty_handler = present(empty_element_handler)
+
+fb => fxml%fb
+fx => fxml%fx
+if (present(verbose)) then
+   debug = verbose                 ! For m_converters
+   fx%debug = verbose              ! job-specific flag
+endif
+
+if (fx%debug) print *, " Entering xml_parse..."
+
+!---------------------------------------------------------------------
+do
+      call get_character(fb,c,iostat)
+
+      if (iostat /= 0) then          ! End of file...
+         if (.not. is_empty(fx%element_stack)) then
+            call build_error_info(error_info, &
+                 "Early end of file.", &
+                 line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
+            if (have_error_handler) then
+               call error_handler(error_info)
+            else
+               call default_error_handler(error_info)
+            endif
+         endif
+         call endfile_xmlfile(fxml)  ! Mark it as eof
+         EXIT
+      endif
+
+      call evolve_fsm(fx,c,signal)
+
+      if (fx%debug) print *, c, " ::: ", trim(fx%action)
+
+      if (signal == END_OF_TAG) then
+         !
+         ! We decide whether we have ended an opening tag or a closing tag
+         !
+         if (fx%context == OPENING_TAG) then
+            name = fx%element_name
+
+            if (fx%debug) print *, "We have found an opening tag"
+            if (fx%root_element_seen) then
+               if (name .equal. fx%root_element_name) then
+                  call build_error_info(error_info, &
+                  "Duplicate root element: " // str(name), &
+                  line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
+                  if (have_error_handler) then
+                     call error_handler(error_info)
+                  else
+                     call default_error_handler(error_info)
+                  endif
+               endif
+               if (is_empty(fx%element_stack)) then
+                  call build_error_info(error_info, &
+                  "Opening tag beyond root context: " // str(name), &
+                  line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
+                  if (have_error_handler) then
+                     call error_handler(error_info)
+                  else
+                     call default_error_handler(error_info)
+                  endif
+               endif
+            else
+               fx%root_element_name = name
+               fx%root_element_seen = .true.
+            endif
+            call push_elstack(name,fx%element_stack)
+            if (have_begin_handler) &
+                call begin_element_handler(str(name),fx%attributes)
+
+         else if (fx%context == CLOSING_TAG) then
+            name = fx%element_name
+         
+            if (fx%debug) print *, "We have found a closing tag"
+            if (is_empty(fx%element_stack)) then
+               call build_error_info(error_info, &
+                  "Nesting error: End tag: " // str(name) //  &
+                  " does not match -- too many end tags", &
+                  line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
+               if (have_error_handler) then
+                  call error_handler(error_info)
+               else
+                  call default_error_handler(error_info)
+               endif
+            else
+               call get_top_elstack(fx%element_stack,oldname)
+               if (oldname .equal. name) then
+                  call pop_elstack(fx%element_stack,oldname)
+                  if (have_end_handler) call end_element_handler(str(name))
+!!                  call pop_elstack(fx%element_stack,oldname)
+               else
+                  call build_error_info(error_info, &
+                       "Nesting error: End tag: " // str(name) //  &
+                       ". Expecting end of : " // str(oldname), &
+                       line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
+                  if (have_error_handler) then
+                     call error_handler(error_info)
+                  else
+                     call default_error_handler(error_info)
+                  endif
+               endif
+            endif
+         else if (fx%context == SINGLE_TAG) then
+            name = fx%element_name
+
+            if (fx%debug) print *, "We have found a single (empty) tag: ", &
+                                char(name)
+            !
+            ! Push name on to stack to reveal true xpath
+            !
+            call push_elstack(name,fx%element_stack)
+            if (have_empty_handler) then
+               if (fx%debug) print *, "--> calling empty_element_handler."
+               call empty_element_handler(str(name),fx%attributes)
+               call pop_elstack(fx%element_stack,dummy)
+            else
+               if (have_begin_handler) then
+                  if (fx%debug) print *, "--> calling begin_element_handler..."
+                  call begin_element_handler(str(name),fx%attributes)
+               endif
+               call pop_elstack(fx%element_stack,dummy)
+               if (have_end_handler) then
+                  if (fx%debug) print *, "--> ... and end_element_handler."
+                  call end_element_handler(str(name))
+               endif
+            endif
+!!            call pop_elstack(fx%element_stack,dummy)
+
+         else if (fx%context == CDATA_SECTION_TAG) then
+
+            if (fx%debug) print *, "We found a CDATA section"
+            if (is_empty(fx%element_stack)) then
+               if (fx%debug) print *, &
+                   "... Warning: CDATA section outside element context"
+            else
+               if (have_cdata_section_handler) then
+                  call cdata_section_handler(str(fx%pcdata))
+               else
+                  if (have_pcdata_handler) &
+                   call pcdata_chunk_handler(str(fx%pcdata))
+               endif
+            endif
+
+         else if (fx%context == COMMENT_TAG) then
+
+            if (fx%debug) print *, "We found a comment tag"
+            if (have_comment_handler)  &
+                 call comment_handler(str(fx%pcdata))
+
+         else if (fx%context == SGML_DECLARATION_TAG) then
+
+            if (fx%debug) print *, "We found an sgml declaration"
+            if (have_sgml_declaration_handler)  &
+                      call sgml_declaration_handler(str(fx%pcdata))
+
+         else if (fx%context == XML_DECLARATION_TAG) then
+
+            if (fx%debug) print *, "We found an XML declaration"
+            name = fx%element_name
+            if (have_xml_declaration_handler)  &
+                      call xml_declaration_handler(str(name),fx%attributes)
+
+         else
+
+            ! do nothing
+
+         endif
+
+      else if (signal == CHUNK_OF_PCDATA) then
+
+         if (fx%debug) print *, "We found a chunk of PCDATA"
+         if (is_empty(fx%element_stack)) then
+            if (fx%debug) print *, "... Warning: PCDATA outside element context"
+               ! Just a warning
+               call build_error_info(error_info, &
+                  "PCDATA outside of element context", &
+                  line(fb),column(fb),fx%element_stack,WARNING_CODE)
+               if (have_error_handler) then
+                  call error_handler(error_info)
+               else
+                  call default_error_handler(error_info)
+               endif
+         else
+            !
+            ! Replace entities by their value
+            !
+            call entity_filter(fx%pcdata,translated_pcdata,status,message)
+            if (status < 0) then
+               call build_error_info(error_info, message, &
+                  line(fb),-status,fx%element_stack,SEVERE_ERROR_CODE)
+               if (have_error_handler) then
+                  call error_handler(error_info)
+               else
+                  call default_error_handler(error_info)
+               endif
+            else if (status > 0) then
+               ! Just a warning
+               call build_error_info(error_info, message, &
+                  line(fb),status,fx%element_stack,WARNING_CODE)
+               if (have_error_handler) then
+                  call error_handler(error_info)
+               else
+                  call default_error_handler(error_info)
+               endif
+            else
+               if (have_pcdata_handler) &
+                   call pcdata_chunk_handler(str(translated_pcdata))
+            endif
+         endif
+
+      else if (signal == EXCEPTION) then
+         call build_error_info(error_info, fx%action, &
+                  line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
+         if (have_error_handler) then
+            call error_handler(error_info)
+         else
+            call default_error_handler(error_info)
+         endif
+      else
+         ! QUIET, do nothing
+      endif
+      if (signal /= QUIET) then
+         if (have_signal_handler) then
+            call signal_handler(pause_signal)
+            if (pause_signal) exit
+         endif
+      endif
+
+enddo
+
+end subroutine xml_parse
+
+!-----------------------------------------
+subroutine xml_path(fxml,path)
+type(xml_t), intent(in) :: fxml
+character(len=*), intent(out)  :: path
+
+call get_elstack_signature(fxml%fx%element_stack,path)
+
+end subroutine xml_path
+
+!-----------------------------------------
+subroutine xml_mark_path(fxml,path)
+!
+! Marks the current path
+!
+type(xml_t), intent(inout) :: fxml
+character(len=*), intent(out)  :: path
+
+call get_elstack_signature(fxml%fx%element_stack,fxml%path_mark)
+path = fxml%path_mark
+
+end subroutine xml_mark_path
+
+!-----------------------------------------
+subroutine xml_get_path_mark(fxml,path)
+!
+! Returns the currently markd path (or an empty string if there are no marks)
+!
+type(xml_t), intent(in)        :: fxml
+character(len=*), intent(out)  :: path
+
+path = fxml%path_mark
+
+end subroutine xml_get_path_mark
+
+!-----------------------------------------
+subroutine xml_name(fxml,name)
+type(xml_t), intent(in) :: fxml
+character(len=*), intent(out)  :: name
+
+name = char(fxml%fx%element_name)
+
+end subroutine xml_name
+!-----------------------------------------
+subroutine xml_attributes(fxml,attributes)
+type(xml_t), intent(in) :: fxml
+type(dictionary_t), intent(out)  :: attributes
+
+attributes = fxml%fx%attributes
+
+end subroutine xml_attributes
+
+end module m_xml_parser
+
+
+
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/flib_wxml.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/flib_wxml.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/flib_wxml.f90	(revision 2528)
@@ -0,0 +1,11 @@
+module flib_wxml
+
+!use m_wxml_buffer
+!use m_wxml_dictionary
+!use m_wxml_elstack
+use m_wxml_text
+use m_wxml_core
+
+public
+
+end module flib_wxml
